<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/helpers/itemid.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since     1.0.14
 */
// no direct access
defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.file');
if (!class_exists('JmylifeConfiguration')) {
	$configfile = JPATH_ROOT.DS.'components'.DS.'com_jmylife'.DS.'libraries'.DS.'configuration.php';
	if( JFile::exists( $configfile ) ) require_once( $configfile );
}

class JmylifeItemidHelper
{
	private static $_instance;
	var $cfg;

	function __construct() {
		$this->cfg = JmylifeConfiguration::getInstance();
	}

	function getInstance() {
		if (!self::$_instance) {
			self::$_instance = new JmylifeItemidHelper();
		}
		return self::$_instance;
	}

	/**
	 * story
	 * @param   object
	 * @param   int
	 * @return  int
	 */
	function story($story, $random=0) {
		$itemid = 0;
		$jmlItemid = 0;
		if (count($this->cfg->menu)) {
			foreach ($this->cfg->menu as $item) {
				$query = $item->query;
				// if menu item matches the exact story, return immediately
				if ('item' == $query['view'] && ((1 == @$query['random'] && 1 == $random) || @$query['id'] == @$story->id)) {
					return intval($item->id);
				}
				// if menu item matches the categories view set $itemid
				// only match this if Itemid is still 0
				if ('categories' == $query['view'] && 0 == $itemid) {
					$itemid = intval($item->id);
				}
				// if menu item matches the story's category set $itemid
				if ('list' == $query['view'] && @$query['catid'] == @$story->catid) {
					$itemid = intval($item->id);
				}
				// set $jmlItemid if main list is found - ignoring best/worst
				if ('list' == $query['view'] && 0 == @$query['catid'] && 'none' == @$query['sort']) {
					$jmlItemid = intval($item->id);
				}
			}
		}
		// favor $itemid over $jmlItemid
		return ($itemid > 0 ? $itemid : $jmlItemid);
	}

	/**
	 * category
	 * @param   int
	 * @param   string
	 * @return  int
	 */
	function category($catid, $sort='none') {
		$itemid = 0;
		if (count($this->cfg->menu)) {
			foreach ($this->cfg->menu as $item) {
				$query = $item->query;
				// if category view is found
				// only set if Itemid is still 0
				if ('categories' == $query['view'] && 0 == $itemid) {
					$itemid = intval($item->id);
				}
				// if menu item matches the story's category return
				if ('list' == $query['view'] && @$query['catid'] == $catid) {
					if (@$query['sort'] == $sort) {
						return intval($item->id);
					}
					$itemid = intval($item->id);
				}
				// if main list is found - ignoring best/worst
				if ('list' == $query['view'] && 0 == @$query['catid'] && @$query['sort'] == $sort) {
					$itemid = intval($item->id);
				}
			}
		}
		// favor $itemid over $jmlItemid
		return $itemid;
	}

	/**
	 * view
	 * @param   string
	 * @return  int
	 */
	function view($view) {
		$itemid = 0;
		if (count($this->cfg->menu)) {
			foreach ($this->cfg->menu as $item) {
				$query = $item->query;
				if ($query['view'] == $view) {
					return intval($item->id);
				}
				if ('list' == $query['view'] && 0 == @$query['catid'] && 'none' == @$query['sort']) {
					$itemid = intval($item->id);
				}
			}
		}
		return $itemid;
	}

}